#!/usr/bin/perl

# Copyright (C) 2002 Red Hat, Inc. All Rights Reserved
# Written by Norm Murray (nmurray@redhat.com)
#
# This program is free software; you can redistribute it and/or
# modify it under terms of the GNU General Public License
# as publishes by the Free Software Foundation; either version 
# 2 of the License, or (at your option) any later version.
#

# Purpose:
#
# 9-19-2002
# Much of this is sort of an ugly hackish start at doing something right. 
# This is very much to be considered a proto-type in an attempt to build 
# a nice interface, taking advantage of what is easily available to start
# putting together something that works. After there's something cobbled 
# together and working, the experience of doing the prototype can be used
# to build a real desktop-printing interface and environment. 


# TODO
# Handle missing 'helpers'... i.e. printing images without gimp... office docs without openoffice
# Keep adding more file type bindings... 
# Don't bother to query if only one lprng printer configured, just use it
# Config file pattern matchings for file sniffing... 


$title = "--title \"Desktop Print Dialog\"";
$printer_list = "";

$homedir = $ENV{'HOME'};

#open(LOG, ">/tmp/tryprint.log");
open(LOG, ">/dev/null");

print LOG "Got $#ARGV arguments to try doing something with\n";



if ($#ARGV < 0) {
    # assume that they are trying to manage queues
    #$msg = "You passed no files to print, starting print queue manager.";
    #$foo = `gdialog $title --infobox "Your print request could not be completed for the following reason: $msg" 40 40 2>&1`;
    `gnome-print-manager`;
    exit;
}



# Go through files... if going to print ourselves, ask once for the printer, 
# if needed (kprinter has it's own dialog, so doesn't need us bothering)
# Additionally, if invoking an app that understands printers, don't bother asking
# either. Only ask once for any number of files that come in.

for ($i = 0; $i <= $#ARGV; $i++) {
    print LOG "Filename $ARGV[$i]\n";
    $thisfile = $ARGV[$i];
# examine file type(s)  dialog user if unprintable... rpm, tar, tgz.. 
# if directory... maybe try working recursively? 

    $fileinfo = `file "$thisfile"`;
    print LOG "\tFile info = $fileinfo";
    if ($fileinfo =~ /:.*?Office.*?/i) {
	# OpenOffice knows how to print... 
	print LOG "Invoking open office to handle office document\n";
	`ooffice $thisfile`;
    } elsif (($fileinfo =~ /:.*?image data.*?/i) || ($fileinfo =~ /:.*?image text.*?/i)  || ($fileinfo =~ /:.*?bitmap data.*?/i)) {
	# Gimp does pretty well with printing images
	print LOG "Invoking gimp to handle image\n";
	`gimp "$thisfile"`;
    } elsif ($fileinfo =~ /:.*?text\W*/i) {
	# this includes ASCII, English, Postscript 
	# last of known formats as 'text' is most generic thing
	print LOG "\tprinting as text\n";
	if ($print_cmd eq "") {
	    get_print_cmd();
	}
	print LOG "Printing: $print_cmd \"$thisfile\"\n";
	`$print_cmd "$thisfile"`;
    } elsif ($fileinfo =~ /:.*?PDF\W*/i) {
	print LOG "\tprinting as PDF\n";
	if ($print_cmd eq "") {
	    get_print_cmd();
	}
	print LOG "Printing: $print_cmd \"thisfile\"\n";
	`$print_cmd "$thisfile"`;
    } else {

	print LOG "Checking filesniff log\n";
	$printed_before = check_printfiletype_config();
	print LOG "Got $printed_before back from check\n";
	if ($printed_before < 1) {
	    if ($printed_before == -1) {
		next;
	    }
	    print LOG "Invoking UI\n";
	    $foo = system("gdialog $title --yesno \"The type of file you are trying to print wasn't recognized and may not print correctly. Would you like to send the file \"$thisfile\" to the printer anyhow?\" 40 40 2>&1");
	    
	    # divide by 256 for correct exit value
	    $foo /= 256;
	    print LOG "Unknown file type: got $foo\n";
	    
	    # yes seems to be even
	    if ($foo % 2) {
		# it's odd, so don't print this
		$increment = -1;
		update_printfiletype_config();
		next;
	    }
	    
	    # so, got a yes. let's try to save the choice with the idea that, record it once
	    # if they print it again, after it's been recorded, let's learn it and not ask them. 
	
	}

	if ($print_cmd eq "") {
	    get_print_cmd();
	}
	print LOG "Printing: $print_cmd \"$thisfile\"\n";
	`$print_cmd "$thisfile"`;

	print LOG "Updating filesniff log\n";
	$increment = 1;
	update_printfiletype_config();

    }

}



print LOG "Done\n";
close LOG;

exit 0;

sub check_printfiletype_config() {

    $fileinfo =~ /:(.*)/;
    $filesniff = $1;
    if ( open(CF, "< ${homedir}/.desktop_printing_filetypes")) {
	print LOG "Check: open succeeded\n";
	while (<CF>) {
	    print LOG "Check: $_ ";
	    if (/$filesniff/) {
		($count, $myfileinfo) = split (":::",$_);
		close CF;
		print LOG "Check: Found previous print of this filetype\n";
		return ($count);
	    }
	}
    }
    close CF;
    return -5;
}


sub update_printfiletype_config() {
    $fileinfo =~ /:(.*)/;
    $filesniff = $1;
    print LOG "Update: Searching for \"$filesniff\"\n";
    if ( open(CF, "< ${homedir}/.desktop_printing_filetypes")) {
	# open succeeded 
	print LOG "Update: open old succeeded\n";
	open(NCF, "> ${homedir}/.desktop_printing_filetypes.new") or return;
	print LOG "Update: open new succeeded\n";
	while ($_ = <CF>) {
	    if ($_ =~ /$filesniff/) {
		$found = 1;
		($count, $myfileinfo) = split(":::", $_);
		if ($count == 0) {
		    print LOG "Update: Found previous print of this filetype, count = 0\n";
		    $count += $increment;
		    print NCF "${count}:::$filesniff\n";
		} else {
		    print LOG "Update: Found previous print of this filetype, count != 0\n";
		    close CF;
		    close NCF;
		    `/bin/rm -f ${homedir}/.desktop_printing_filetypes.new`;
		    return;
		}
	    } else {
		print NCF $_;
	    }
	}
	if (!$found) {
	    print LOG "Update: Didn't find \"$filesniff\", adding now\n";
	    print NCF "0:::$filesniff\n";
	}
	close CF;
	close NCF;
	`mv ${homedir}/.desktop_printing_filetypes.new ${homedir}/.desktop_printing_filetypes`;
	return;
    } else {
	print LOG "Update: Creating ${homedir}/.desktop_printing_filetypes\n";
	if (!open(CF, "> ${homedir}/.desktop_printing_filetypes")) {
	    print LOG "Update: Creating - file opened\n";
	    print CF "# Format is <number>:::<output of the file command>\n";
	    print CF "# -1 is don't print, don't ask\n";
	    print CF "# 0 is have asked once\n";
	    print CF "# 1 is print and don't ask\n";
	    print CF "#\n# pretty simple, but so is the whole thing at this point\n";
	    print CF "0:::$filesniff\n";
	    close CF;
	} else {
	    print LOG "Something oopsied in creation\n";
	}
    }
}




sub get_printers_from_printcap() {
    print LOG "Looking up printer names..... \n";
    
    # want to build a list the way to display in gdialog
    if (! (open (PC, "</etc/printcap"))) {
	print LOG "Couldn't open printcap\n";
	$msg = "Couldn't determine printer names";
	my_abort();
    }
    $printer_list = "";
    $printer_count = 0;
    while (<PC>) {
	# skip comments, blank lines and lines in the middle of a stanza
	if ( (/^\w*\n/) || (/^\W*:/) || (/^\w*\#/))  { 
	    next;
	}

	# what's left SHOULD be defining a printer... 
	if (/^\W*([\w-\|]*):/) {
	    $printer_count++;
	    $new_printer = "";
	    $remainder = $1;
	    while ($remainder =~ /\|/) {
		($item, $remainder) = split(/\|/, $remainder,2);
		if ($new_printer) { 
		    # already havve something added, just adding the name
		    $new_printer = "$new_printer $item";
		} else {
		    # use first item as the tag, start string
		    $new_printer = "$item \"$item";
		}

	    }
	    if (! $new_printer) {
		# No alternative names for this one, do everything
		$new_printer = "$remainder \"$remainder\" dummystatus";
	    } else {
		# Last in a list
		$new_printer = "$new_printer $remainder\" dummystatus";
	    }
	    $printer_list = "$printer_list $new_printer";
	}
    }
    if ($printer_list eq "") {
	# no printers configured
	$msg = "You have no printers configured. You might want to run system-config-printer to set up some printers.";
	my_abort();
    }
	    
	
}


sub get_print_cmd () {

# Determine print system installed

# Red Hat Linux (Milan) print detection
    $print = `ls -l /etc/alternatives/print`;
    if ($print =~ /LPRng/) {
	print LOG "Found LPRng\n";
	get_printers_from_printcap();
	$foo = `gdialog $title --radiolist "Which of these defined printers would you like to use?" 50 150 $printer_count $printer_list 2>&1`;
	print "Got $foo from gdialog\n";
    if ($foo eq "") {
	$msg = "Can't print without a printer being selected";
	my_abort();
    }
	chomp $foo;
	$print_cmd = "lpr -P $foo ";
    } else {
	print LOG "Found CUPS\n";
	if (-x "/usr/bin/kprinter") {
	    $print_cmd = "kprinter";
	} else { $print_cmd = "/usr/share/printconf/util/print.py"; }
    }
    
}



sub my_abort() {

    $foo = `gdialog $title --infobox "Your print request could not be completed for the following reason: $msg" 40 40 2>&1`;
    exit;
}
